/** @license ISC License (c) copyright 2017 original and current authors */
/** @author Ian Hofmann-Hicks (evil) */

var ref = require('.');
var Err = ref.Err;
var Ok = ref.Ok;
var curry = require('../core/curry')
var isFunction = require('../core/isFunction')

function tryCatch(fn) {
  if(!isFunction(fn)) {
    throw new TypeError('tryCatch: Function required for first argument')
  }

  return function(x) {
    try { return Ok(fn(x)) }
    catch(e) { return Err(e) }
  }
}

module.exports = curry(tryCatch)
