/** @license ISC License (c) copyright 2017 original and current authors */
/** @author Ian Hofmann-Hicks (evil) */

var curry = require('../core/curry')
var isObject = require('../core/isObject')
var isString = require('../core/isString')
var object = require('../core/object')

// assoc : String -> a -> Object -> Object
function assoc(key, val, obj) {
  var obj$1;

  if(!isString(key)) {
    throw new TypeError('assoc: String required for first argument')
  }

  if(!isObject(obj)) {
    throw new TypeError('assoc: Object required for third argument')
  }
  return object.assign(( obj$1 = {}, obj$1[key] = val, obj$1 ), obj)
}

module.exports = curry(assoc)
