/** @license ISC License (c) copyright 2017 original and current authors */
/** @author Henrique Limas */
/** @author Ian Hofmann-Hicks */

var curry = require('../core/curry')
var isDefined = require('../core/isDefined')
var isEmpty = require('../core/isEmpty')
var isNil = require('../core/isNil')
var isInteger = require('../core/isInteger')
var isString = require('../core/isString')

// propOr : a -> String | Integer -> b -> c
function propOr(def, key, target) {
  if(!(isString(key) && !isEmpty(key) || isInteger(key))) {
    throw new TypeError('propOr: Non-empty String or Integer required for second argument')
  }

  if(isNil(target)) {
    return def
  }

  var value = target[key]

  return isDefined(value)
    ? value
    : def
}

module.exports = curry(propOr)
