/** @license ISC License (c) copyright 2016 original and current authors */
/** @author Ian Hofmann-Hicks (evil) */

var isArray = require('../core/isArray')
var isFunction = require('../core/isFunction')
var isString = require('../core/isString')

var ref = require('../core/Maybe');
var Nothing = ref.Nothing;
var Just = ref.Just;

function head(m) {
  if(m && isFunction(m.head)) {
    return m.head()
  }

  if(isArray(m) || isString(m)) {
    return !m.length
      ? Nothing()
      : Just(m[0])
  }

  throw new TypeError('head: Array, String or List required')
}

module.exports = head
